/*
 * nScore
 *
 * General.h
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_NSCORE_GENERAL_H
#define _INC_NSCORE_GENERAL_H

/* Include Files */

/* Define */
#define BUF_SIZE					256

#define APP_NAME					TEXT("nScore Ver 0.1.6")

#define FONT_NAME					TEXT("Arial")
#define SCORE_FONT_NAME				TEXT("Arial")

#define GAME_TYPE_01				1
#define GAME_TYPE_CRICKET			2
#define GAME_TYPE_COUNTUP			3
#define GAME_TYPE_CRICKET_COUNTUP	4
#define GAME_TYPE_EAGLESEYE			5
#define GAME_TYPE_HALFIT			6
#define GAME_TYPE_ROTATION			7
#define GAME_TYPE_SPLAT				8

#define PLAYER_MAX					4
#define THROW_MAX					3

#define CHAR_SINGLE					TEXT('S')
#define CHAR_SINGLE_LOWER			TEXT('s')
#define CHAR_DOUBLE					TEXT('D')
#define CHAR_DOUBLE_LOWER			TEXT('d')
#define CHAR_TRIPLE					TEXT('T')
#define CHAR_TRIPLE_LOWER			TEXT('t')

#define WM_SET_STATUS				(WM_APP + 1)

/* Struct */
typedef struct _COLOR_INFO {
	COLORREF text;
	COLORREF background;
	COLORREF focus_text;
	COLORREF focus_background;
	COLORREF winner_text;
	COLORREF winner_background;
	COLORREF close_text;
	COLORREF spoiler_text;
	COLORREF bust_text;
	COLORREF line;
} COLOR_INFO;

typedef struct _OPTION_INFO {
	RECT window_rect;
	int window_state;
	int window_status_bar;

	int board_size;
} OPTION_INFO;

#endif
/* End of source */
