/*
 * nScore
 *
 * robo_cricket.c
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "General.h"
#include "Message.h"
#include "score_cricket.h"

#include "resource.h"

/* Define */
#define MAX_LEVEL		7

/* Global Variables */

/* Local Function Prototypes */

/*
 * robo_get_throw - xɉ_擾
 */
int robo_get_throw(const int lv, const int number, TCHAR *ret)
{
	int board[21][2] = {
		{ 0,  0},	//0
		{20, 18},	//1
		{15, 17},	//2
		{17, 19},	//3
		{18, 13},	//4
		{12, 20},	//5
		{13, 10},	//6
		{19, 16},	//7
		{16, 11},	//8
		{14, 12},	//9
		{ 6, 15},	//10
		{ 8, 14},	//11
		{ 9,  5},	//12
		{ 4,  6},	//13
		{11,  9},	//14
		{10,  2},	//15
		{ 7,  8},	//16
		{ 2,  3},	//17
		{ 1,  4},	//18
		{ 3,  7},	//19
		{ 5,  1},	//20
	};
	int rate_triple[MAX_LEVEL] = {1, 10, 15, 30, 60, 90, 100};
	int rate_double[MAX_LEVEL] = {1, 1, 1, 1, 1, 1, 100};
	int rate_single[MAX_LEVEL] = {10, 50, 75, 90, 90, 90, 100};
	int rate_bull[MAX_LEVEL] = {10, 20, 30, 50, 70, 90, 100};
	int i, j;

	*ret = TEXT('\0');

	// ̏
	srand((unsigned)GetTickCount());

	// ԍ
	i = number;
	if (i == -1) {
		i = rand() % 21;
	}
	if (i == 0) {
		// bull
		if ((rand() % 100) + 1 > rate_bull[lv - 1]) {
			// Lb`
			i = rand() % 21;
		}
		if (i == 0) {
			if ((rand() % 100) + 1 <= rate_triple[lv - 1]) {
				lstrcpy(ret, message_get_res(IDS_STRING_D_BULL));
			} else {
				lstrcpy(ret, message_get_res(IDS_STRING_S_BULL));
			}
		} else {
			wsprintf(ret, TEXT("%s %d"), message_get_res(IDS_STRING_SINGLE), i);
		}
		return i;
	}

	// ̈挈
	j = rand() % 2;
	do {
		if ((rand() % 100) + 1 <= rate_triple[lv - 1]) {
			// gv
			wsprintf(ret, TEXT("%s %d"), message_get_res(IDS_STRING_TRIPLE), i);
		} else if ((rand() % 100) + 1 <= rate_double[lv - 1]) {
			// _u
			wsprintf(ret, TEXT("%s %d"), message_get_res(IDS_STRING_DOUBLE), i);
		} else if ((rand() % 100) + 1 <= rate_single[lv - 1]) {
			// VO
			wsprintf(ret, TEXT("%s %d"), message_get_res(IDS_STRING_SINGLE), i);
		} else {
			// Lb`
			i = board[i][j];
		}
	} while (*ret == TEXT('\0'));

	return i;
}

/*
 * get_rank - ʎ擾
 */
int get_rank(const CRICKET_INFO *cri, const int player)
{
	int ret = 1;
	int j;

	for (j = 0; j < cri->player_cnt; j++) {
		if (cri->cut_throat == TRUE && cri->player_cnt > 2) {
			if (j != player && cri->pi[player].score + cri->tmp_score[player] >= cri->pi[j].score + cri->tmp_score[j]) {
				ret++;
			}
		} else {
			if (j != player && cri->pi[player].score + cri->tmp_score[player] <= cri->pi[j].score + cri->tmp_score[j]) {
				ret++;
			}
		}
	}
	return ret;
}

/*
 * get_rank_to_player - ʂvC[擾
 */
int get_rank_to_player(const CRICKET_INFO *cri, const int rank)
{
	int ranking[PLAYER_MAX];
	int n;
	int i, j;

	ZeroMemory(ranking, sizeof(int) * PLAYER_MAX);
	for (i = 0; i < cri->player_cnt; i++) {
		n = 0;
		for (j = 0; j < cri->player_cnt; j++) {
			if (cri->cut_throat == TRUE && cri->player_cnt > 2) {
				if (j != i && cri->pi[i].score + cri->tmp_score[i] > cri->pi[j].score + cri->tmp_score[j]) {
					n++;
				}
			} else {
				if (j != i && cri->pi[i].score + cri->tmp_score[i] < cri->pi[j].score + cri->tmp_score[j]) {
					n++;
				}
			}
		}
		while (ranking[n] != 0) {
			n++;
		}
		ranking[n] = i + 1;
	}
	return (ranking[rank - 1] - 1);
}

/*
 * is_close - Ă邩`FbN 
 */
BOOL is_close(const CRICKET_INFO *cri, const int player, const int mark)
{
	if (cri->pi[player].spoiler == TRUE) {
		return TRUE;
	}
	if (player == cri->current_player) {
		if (cri->tmp_mark[mark] >= MARK_CNT) {
			return TRUE;
		}
	} else {
		if (cri->pi[player].mark[mark] >= MARK_CNT) {
			return TRUE;
		}
	}
	return FALSE;
}

/*
 * get_close_count - Ă鐔擾
 */
int get_close_count(const CRICKET_INFO *cri, const int player)
{
	int ret = 0;
	int i;

	for (i = 0; i < NUMBER_CNT; i++) {
		if (player == cri->current_player) {
			if (cri->tmp_mark[i] >= MARK_CNT) {
				ret++;
			}
		} else {
			if (cri->pi[player].mark[i] >= MARK_CNT) {
				ret++;
			}
		}
	}
	return ret;
}

/*
 * get_only_close_number - ̂ݕĂő̔ԍ擾 
 */
int get_only_close_number(const CRICKET_INFO *cri, const int player)
{
	int ret = -1;
	int i, j;

	for (i = 0; i < NUMBER_CNT; i++) {
		if (player == cri->current_player) {
			if (cri->tmp_mark[i] < MARK_CNT) {
				continue;
			}
		} else {
			if (cri->pi[player].mark[i] < MARK_CNT) {
				continue;
			}
		}
		for (j = 0; j < cri->player_cnt; j++) {
			if (player != cri->current_player && j == cri->current_player) {
				if (j != player && cri->pi[j].spoiler == FALSE && cri->tmp_mark[i] >= MARK_CNT) {
					break;
				}
			} else {
				if (j != player && cri->pi[j].spoiler == FALSE && cri->pi[j].mark[i] >= MARK_CNT) {
					break;
				}
			}
		}
		if (j >= cri->player_cnt && ret < cri->number[i]) {
			ret = cri->number[i];
		}
	}
	return ret;
}

/*
 * get_only_open_number - ̂݊JĂő̔ԍ擾 
 */
int get_only_open_number(const CRICKET_INFO *cri, const int player)
{
	int ret = -1;
	int i, j;

	for (i = 0; i < NUMBER_CNT; i++) {
		if (player == cri->current_player) {
			if (cri->tmp_mark[i] >= MARK_CNT) {
				continue;
			}
		} else {
			if (cri->pi[player].mark[i] >= MARK_CNT) {
				continue;
			}
		}
		for (j = 0; j < cri->player_cnt; j++) {
			if (player != cri->current_player && j == cri->current_player) {
				if (j != player && cri->pi[j].spoiler == FALSE && cri->tmp_mark[i] < MARK_CNT) {
					break;
				}
			} else {
				if (j != player && cri->pi[j].spoiler == FALSE && cri->pi[j].mark[i] < MARK_CNT) {
					break;
				}
			}
		}
		if (j >= cri->player_cnt && ret < cri->number[i]) {
			ret = cri->number[i];
		}
	}
	return ret;
}

/*
 * get_no_close_number - ĂȂő̔ԍ擾
 */
int get_no_close_number(const CRICKET_INFO *cri, const int player)
{
	int ret = -1;
	int i;

	for (i = 0; i < NUMBER_CNT; i++) {
		if (player == cri->current_player) {
			if (cri->tmp_mark[i] >= MARK_CNT) {
				continue;
			}
		} else {
			if (cri->pi[player].mark[i] >= MARK_CNT) {
				continue;
			}
		}
		if (ret < cri->number[i]) {
			ret = cri->number[i];
		}
	}
	return ret;
}

/*
 * get_open_number - NĂȂő̔ԍ擾
 */
int get_open_number(const CRICKET_INFO *cri)
{
	int ret = -1;
	int i, j;

	for (i = 0; i < NUMBER_CNT; i++) {
		for (j = 0; j < cri->player_cnt; j++) {
			if (j == cri->current_player) {
				if (cri->tmp_mark[i] >= MARK_CNT) {
					break;
				}
			} else  {
				if (cri->pi[j].spoiler == FALSE && cri->pi[j].mark[i] >= MARK_CNT) {
					break;
				}
			}
		}
		if (j >= cri->player_cnt && ret < cri->number[i]) {
			ret = cri->number[i];
		}
	}
	return ret;
}

/*
 * get_max_number - ő̔ԍ擾
 */
int get_max_number(const CRICKET_INFO *cri, const int player)
{
	int ret = -1;
	int i, j;

	for (i = 0; i < NUMBER_CNT; i++) {
		for (j = 0; j < cri->player_cnt; j++) {
			if (player != cri->current_player && j == cri->current_player) {
				if (j != player && cri->pi[j].spoiler == FALSE && cri->tmp_mark[i] < MARK_CNT) {
					break;
				}
			} else {
				if (j != player && cri->pi[j].spoiler == FALSE && cri->pi[j].mark[i] < MARK_CNT) {
					break;
				}
			}
		}
		if (j < cri->player_cnt && ret < cri->number[i]) {
			ret = cri->number[i];
		}
	}
	return ret;
}

/*
 * get_mark_number - w萔}[NtĂő̔ԍ擾
 */
int get_mark_number(const CRICKET_INFO *cri, const int player, const int mark)
{
	int ret = -1;
	int i;

	for (i = 0; i < NUMBER_CNT; i++) {
		if (player == cri->current_player) {
			if (cri->tmp_mark[i] != mark) {
				continue;
			}
		} else {
			if (cri->pi[player].mark[i] != mark) {
				continue;
			}
		}
		if (ret < cri->number[i]) {
			ret = cri->number[i];
		}
	}
	return ret;
}
/* End of source */
