/*
 * nScore
 *
 * robo_cricket_pattern.c
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "general.h"
#include "score_cricket.h"
#include "robo_cricket.h"
#include "robo_cricket_pattern.h"

/* Define */

/* Global Variables */

/* Local Function Prototypes */
static int WINAPI robo_type_std(const HWND hWnd, CRICKET_INFO *cri, const int player, const int throw_cnt);
static int WINAPI robo_type_score(const HWND hWnd, CRICKET_INFO *cri, const int player, const int throw_cnt);
static int WINAPI robo_type_mark(const HWND hWnd, CRICKET_INFO *cri, const int player, const int throw_cnt);

/*
 * get_robo_info - {擾
 */
BOOL get_robo_info(CRICKET_ROBO_INFO *cr_ri, const int index)
{
	if (index >= ROBO_CNT) {
		return FALSE;
	}

	switch (index) {
	case 0:
		lstrcpy(cr_ri->name, TEXT("Type-A"));
		cr_ri->func = robo_type_std;
		return TRUE;

	case 1:
		lstrcpy(cr_ri->name, TEXT("Type-B"));
		cr_ri->func = robo_type_score;
		return TRUE;

	case 2:
		lstrcpy(cr_ri->name, TEXT("Type-C"));
		cr_ri->func = robo_type_mark;
		return TRUE;
	}
	return FALSE;
}

/*
 * robo_type_std - W{
 */
static int WINAPI robo_type_std(const HWND hWnd, CRICKET_INFO *cri, const int player, const int throw_cnt)
{
	int num = -1;

	if (get_rank(cri, player) != 1) {
		// 1ʂł͂Ȃꍇ
		if (cri->cut_throat == TRUE && cri->player_cnt > 2) {
			// ̂ݕĂԍ
			num = get_only_close_number(cri, player);
			if (num == -1) {
				// ܂NĂȂԍ
				num = get_open_number(cri);
				if (num == -1) {
					// 1ʂĂȂԍ
					num = get_no_close_number(cri, get_rank_to_player(cri, 1));
				}
			}
		} else {
			if (cri->player_cnt == 2) {
				// ̂ݕĂԍ
				num = get_only_close_number(cri, player);
				if (num == -1) {
					// ő̔ԍ
					num = get_max_number(cri, player);
				}
			} else {
				// ő̔ԍ
				num = get_max_number(cri, player);
			}
		}
	} else {
		// ̂݊JĂԍ
		num = get_only_open_number(cri, player);
	}
	if (num == -1) {
		// 2}[NtĂԍ
		num = get_mark_number(cri, player, 2);
		if (num == -1) {
			// ܂ĂȂԍ
			num = get_no_close_number(cri, player);
			if (num == -1) {
				// ő̔ԍ
				num = get_max_number(cri, player);
			}
		}
	}
	return num;
}

/*
 * robo_type_score - XRAd{
 */
static int WINAPI robo_type_score(const HWND hWnd, CRICKET_INFO *cri, const int player, const int throw_cnt)
{
	int num = -1;
	int score;

	if (cri->over_kill == TRUE && cri->player_cnt == 2) {
		// Ƃ̓_擾
		score = cri->pi[0].score - cri->pi[1].score;
		if (score < 0) {
			score *= -1;
		}
	}
	if (get_rank(cri, player) != 1) {
		// 1ʂł͂Ȃꍇ
		if (cri->cut_throat == TRUE && cri->player_cnt > 2) {
			if (get_only_close_number(cri, player) >= get_no_close_number(cri, get_rank_to_player(cri, 1))) {
				// ̂ݕĂԍ
				num = get_only_close_number(cri, player);
			} else if (num == -1) {
				if (get_open_number(cri) > get_no_close_number(cri, get_rank_to_player(cri, 1))) {
					// ܂NĂȂԍ
					num = get_open_number(cri);
				} else {
					// 1ʂĂȂԍ
					num = get_no_close_number(cri, get_rank_to_player(cri, 1));
				}
			}
		}
	} else if (cri->over_kill == TRUE && cri->player_cnt == 2 && score > 200) {
		// I[o[Lꍇ
		// ̂݊JĂԍ
		num = get_only_open_number(cri, player);
		if (num == -1) {
			// ܂ĂȂԍ
			num = get_no_close_number(cri, player);
		}
	} else if (cri->cut_throat == TRUE && cri->player_cnt > 2) {
		if (get_only_close_number(cri, player) >= get_no_close_number(cri, get_rank_to_player(cri, 2))) {
			// ̂ݕĂԍ
			num = get_only_close_number(cri, player);
		} else if (num == -1) {
			if (get_open_number(cri) > get_no_close_number(cri, get_rank_to_player(cri, 2))) {
				// ܂NĂȂԍ
				num = get_open_number(cri);
			} else {
				// 2ʂĂȂԍ
				num = get_no_close_number(cri, get_rank_to_player(cri, 2));
			}
		}
	}
	if (num == -1) {
		// ő̔ԍ
		num = get_max_number(cri, player);
		if (num == -1) {
			// 2}[NtĂԍ
			num = get_mark_number(cri, player, 2);
			if (num == -1) {
				// ܂ĂȂԍ
				num = get_no_close_number(cri, player);
			}
		}
	}
	return num;
}

/*
 * robo_type_mark - }[Nd{
 */
static int WINAPI robo_type_mark(const HWND hWnd, CRICKET_INFO *cri, const int player, const int throw_cnt)
{
	int num = -1;

	if (get_rank(cri, player) != 1) {
		// 1ʂł͂Ȃꍇ
		if (cri->cut_throat == TRUE && cri->player_cnt > 2) {
			// ̂݊JĂԍ
			num = get_only_open_number(cri, player);
			if (num == -1) {
				// 2}[NtĂԍ
				num = get_mark_number(cri, player, 2);
				if (num == -1) {
					// ܂ĂȂԍ
					num = get_no_close_number(cri, player);
					if (num == -1) {
						// ̂ݕĂԍ
						num = get_only_close_number(cri, player);
					}
				}
			}
		} else {
			// ̂݊JĂԍ
			num = get_only_open_number(cri, player);
		}
	}
	if (num == -1) {
		// 2}[NtĂԍ
		num = get_mark_number(cri, player, 2);
		if (num == -1) {
			// ܂ĂȂԍ
			num = get_no_close_number(cri, player);
			if (num == -1) {
				// ő̔ԍ
				num = get_max_number(cri, player);
			}
		}
	}
	return num;
}
/* End of source */
