/*
 * nScore
 *
 * score_01.h
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_SCORE_01_H
#define _INC_SCORE_01_H

/* Include Files */
#include "general.h"

/* Define */
#define ZEROONE_ROUND_MAX			50

/* Struct */
typedef struct _ZEROONE_ROUND_INFO {
	int score_list;
	TCHAR throw_list[THROW_MAX][BUF_SIZE];
} ZEROONE_ROUND_INFO;

typedef struct _ZEROONE_PLAYER_INFO {
	TCHAR name[BUF_SIZE];
	int score;
	int darts;

	BOOL double_in;
	int double_in_flag;
	BOOL double_out;

	ZEROONE_ROUND_INFO ri[ZEROONE_ROUND_MAX];
} ZEROONE_PLAYER_INFO;

typedef struct _ZEROONE_INFO {
	BOOL game_flag;

	int init_score;
	int player_cnt;
	int round_cnt;
	BOOL op_bull;
	BOOL stats_80per;

	int current_round;
	int current_player;
	int average_round;
	int average_player;
	int list_index;

	ZEROONE_PLAYER_INFO pi[PLAYER_MAX];

} ZEROONE_INFO;

/* Function Prototypes */
float get_01_average(const ZEROONE_INFO *zi, const int player, float *ret1, float *ret2);
BOOL score_01_regist(const HINSTANCE hInstance);
HWND score_01_create(const HINSTANCE hInstance, const HWND pWnd, int id, const int height);

#endif
/* End of source */
