/*
 * nScore
 *
 * score_cricket.h
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_SCORE_CRICKET_H
#define _INC_SCORE_CRICKET_H

/* Include Files */
#include "general.h"

/* Define */
#define NUMBER_CNT					7
#define MARK_CNT					3
#define CRICKET_ROUND_MAX			50

/* Struct */
typedef struct _CRICKET_ROUND_INFO {
	int mark_list[NUMBER_CNT];
	int mark_cnt;
	int score_list;
	int prev_score_list[PLAYER_MAX];
	TCHAR throw_list[THROW_MAX][BUF_SIZE];
} CRICKET_ROUND_INFO;

typedef struct _CRICKET_PLAYER_INFO {
	TCHAR name[BUF_SIZE];

	int mark[NUMBER_CNT];
	int score;

	BOOL spoiler;

	BOOL robo;
	int robo_lv;
	int robo_index;

	CRICKET_ROUND_INFO ri[CRICKET_ROUND_MAX];
} CRICKET_PLAYER_INFO;

typedef struct _CRICKET_INFO {
	BOOL game_flag;

	int player_cnt;
	int round_cnt;

	int current_round;
	int current_player;
	int average_round;
	int average_player;
	int list_index;

	int tmp_mark[NUMBER_CNT];
	int tmp_score[PLAYER_MAX];

	int number[NUMBER_CNT];

	BOOL hidden;
	BOOL random;
	BOOL cut_throat;
	BOOL over_kill;
	BOOL stats_80per;

	CRICKET_PLAYER_INFO pi[PLAYER_MAX];
} CRICKET_INFO;

/* Function Prototypes */
float get_cricket_average(const CRICKET_INFO *cri, const int player, float *ret1, float *ret2);
BOOL score_cricket_regist(const HINSTANCE hInstance);
HWND score_cricket_create(const HINSTANCE hInstance, const HWND pWnd, int id, const int height);

#endif
/* End of source */
