/*
 * nScore
 *
 * score_cricket_option.c
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "General.h"
#include "Message.h"
#include "score_cricket.h"
#include "robo_cricket_pattern.h"
#include "ini.h"

#include "resource.h"

/* Define */
#ifdef _DEBUG
#define ROBO_MAX_LEVEL			7
#else
#define ROBO_MAX_LEVEL			6
#endif

/* Global Variables */
extern TCHAR ini_path[MAX_PATH];

extern CRICKET_ROBO_INFO cr_ri[10];
extern int cr_ri_cnt;

/* Local Function Prototypes */
static void set_enable(const HWND hDlg);
static BOOL CALLBACK option_cricket_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * set_enable - Rg[̏Ԑݒ
 */
static void set_enable(const HWND hDlg)
{
	int i;

	// vC[̎擾
	if (IsDlgButtonChecked(hDlg, IDC_RADIO_P2) == 1) {
		i = 2;
	} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P3) == 1) {
		i = 3;
	} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P4) == 1) {
		i = 4;
	}

	// hidden̏ꍇ̓{
	if (IsDlgButtonChecked(hDlg, IDC_RADIO_HIDDEN) == 1) {
		CheckDlgButton(hDlg, IDC_CHECK_R1, FALSE);
		CheckDlgButton(hDlg, IDC_CHECK_R2, FALSE);
		CheckDlgButton(hDlg, IDC_CHECK_R3, FALSE);
		CheckDlgButton(hDlg, IDC_CHECK_R4, FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R1), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R2), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R3), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R4), FALSE);
	} else {
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R1), TRUE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R2), TRUE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R3), TRUE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R4), TRUE);
	}
	// {ݒ
	if (IsDlgButtonChecked(hDlg, IDC_CHECK_R1) == 1) {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT_P1), SW_HIDE);
		ShowWindow(GetDlgItem(hDlg, IDC_COMBO_R1), SW_SHOW);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R1_LV), TRUE);
	} else {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT_P1), SW_SHOW);
		ShowWindow(GetDlgItem(hDlg, IDC_COMBO_R1), SW_HIDE);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R1_LV), FALSE);
	}
	if (IsDlgButtonChecked(hDlg, IDC_CHECK_R2) == 1) {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT_P2), SW_HIDE);
		ShowWindow(GetDlgItem(hDlg, IDC_COMBO_R2), SW_SHOW);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R2_LV), TRUE);
	} else {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT_P2), SW_SHOW);
		ShowWindow(GetDlgItem(hDlg, IDC_COMBO_R2), SW_HIDE);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R2_LV), FALSE);
	}
	if (IsDlgButtonChecked(hDlg, IDC_CHECK_R3) == 1) {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT_P3), SW_HIDE);
		ShowWindow(GetDlgItem(hDlg, IDC_COMBO_R3), SW_SHOW);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R3_LV), TRUE);
	} else {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT_P3), SW_SHOW);
		ShowWindow(GetDlgItem(hDlg, IDC_COMBO_R3), SW_HIDE);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R3_LV), FALSE);
	}
	if (IsDlgButtonChecked(hDlg, IDC_CHECK_R4) == 1) {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT_P4), SW_HIDE);
		ShowWindow(GetDlgItem(hDlg, IDC_COMBO_R4), SW_SHOW);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R4_LV), TRUE);
	} else {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT_P4), SW_SHOW);
		ShowWindow(GetDlgItem(hDlg, IDC_COMBO_R4), SW_HIDE);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R4_LV), FALSE);
	}

	// Rg[Lɐݒ
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P2), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P3), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P4), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R2), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R3), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R4), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_CUTTHROAT), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_OVER_KILL), FALSE);

	// lɉăRg[ݒ
	switch (i) {
	case 1:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P2), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R2), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R2), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R2_LV), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_CUTTHROAT), FALSE);
	case 2:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P3), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R3), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R3), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R3_LV), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_CUTTHROAT), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_OVER_KILL), TRUE);
	case 3:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P4), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R4), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_R4), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_R4_LV), FALSE);
		break;
	}
}

/*
 * init_robo_info - {̏
 */
static void init_robo_info(const HWND cmb_robo, const HWND cmb_lv)
{
	TCHAR buf[BUF_SIZE];
	int i;

	for (i = 0; i < cr_ri_cnt; i++) {
		SendMessage(cmb_robo, CB_ADDSTRING, 0, (LPARAM)cr_ri[i].name);
	}
	for (i = 0; i < ROBO_MAX_LEVEL; i++) {
		wsprintf(buf, TEXT("%d"), i + 1);
		SendMessage(cmb_lv, CB_ADDSTRING, 0, (LPARAM)buf);
	}
}

/*
 * option_cricket_proc - Q[ݒEBhEvV[W
 */
static BOOL CALLBACK option_cricket_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	CRICKET_INFO *cri;
	int i, j;

	switch (msg) {
	case WM_INITDIALOG:
		if ((cri = (CRICKET_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}

		// 
		if (cri->hidden == TRUE) {
			CheckDlgButton(hDlg, IDC_RADIO_HIDDEN, 1);
		} else if (cri->random == TRUE) {
			CheckDlgButton(hDlg, IDC_RADIO_RANDOM, 1);
		} else {
			CheckDlgButton(hDlg, IDC_RADIO_STANDARD, 1);
		}
		SetDlgItemInt(hDlg, IDC_EDIT_ROUND, cri->round_cnt, FALSE);

		// vC[ݒ
		switch (cri->player_cnt) {
		case 2:
		default:
			CheckDlgButton(hDlg, IDC_RADIO_P2, 1);
			break;
		case 3:
			CheckDlgButton(hDlg, IDC_RADIO_P3, 1);
			break;
		case 4:
			CheckDlgButton(hDlg, IDC_RADIO_P4, 1);
			break;
		}
		// O
		SendDlgItemMessage(hDlg, IDC_EDIT_P1, WM_SETTEXT, 0,
			(LPARAM)((*cri->pi[0].name != TEXT('\0')) ? cri->pi[0].name : message_get_res(IDS_STRING_DEF_PLAYER_1)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P2, WM_SETTEXT, 0,
			(LPARAM)((*cri->pi[1].name != TEXT('\0')) ? cri->pi[1].name : message_get_res(IDS_STRING_DEF_PLAYER_2)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P3, WM_SETTEXT, 0,
			(LPARAM)((*cri->pi[2].name != TEXT('\0')) ? cri->pi[2].name : message_get_res(IDS_STRING_DEF_PLAYER_3)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P4, WM_SETTEXT, 0,
			(LPARAM)((*cri->pi[3].name != TEXT('\0')) ? cri->pi[3].name : message_get_res(IDS_STRING_DEF_PLAYER_4)));
		
		// {
		init_robo_info(GetDlgItem(hDlg, IDC_COMBO_R1), GetDlgItem(hDlg, IDC_COMBO_R1_LV));
		init_robo_info(GetDlgItem(hDlg, IDC_COMBO_R2), GetDlgItem(hDlg, IDC_COMBO_R2_LV));
		init_robo_info(GetDlgItem(hDlg, IDC_COMBO_R3), GetDlgItem(hDlg, IDC_COMBO_R3_LV));
		init_robo_info(GetDlgItem(hDlg, IDC_COMBO_R4), GetDlgItem(hDlg, IDC_COMBO_R4_LV));
		CheckDlgButton(hDlg, IDC_CHECK_R1, cri->pi[0].robo);
		CheckDlgButton(hDlg, IDC_CHECK_R2, cri->pi[1].robo);
		CheckDlgButton(hDlg, IDC_CHECK_R3, cri->pi[2].robo);
		CheckDlgButton(hDlg, IDC_CHECK_R4, cri->pi[3].robo);
		SendDlgItemMessage(hDlg, IDC_COMBO_R1, CB_SETCURSEL, cri->pi[0].robo_index, 0);
		SendDlgItemMessage(hDlg, IDC_COMBO_R2, CB_SETCURSEL, cri->pi[1].robo_index, 0);
		SendDlgItemMessage(hDlg, IDC_COMBO_R3, CB_SETCURSEL, cri->pi[2].robo_index, 0);
		SendDlgItemMessage(hDlg, IDC_COMBO_R4, CB_SETCURSEL, cri->pi[3].robo_index, 0);
		SendDlgItemMessage(hDlg, IDC_COMBO_R1_LV, CB_SETCURSEL, cri->pi[0].robo_lv, 0);
		SendDlgItemMessage(hDlg, IDC_COMBO_R2_LV, CB_SETCURSEL, cri->pi[1].robo_lv, 0);
		SendDlgItemMessage(hDlg, IDC_COMBO_R3_LV, CB_SETCURSEL, cri->pi[2].robo_lv, 0);
		SendDlgItemMessage(hDlg, IDC_COMBO_R4_LV, CB_SETCURSEL, cri->pi[3].robo_lv, 0);

		// IvV
		if (cri->cut_throat == TRUE) {
			CheckDlgButton(hDlg, IDC_CHECK_CUTTHROAT, 1);
		}
		if (cri->over_kill == TRUE) {
			CheckDlgButton(hDlg, IDC_CHECK_OVER_KILL, 1);
		}
		if (cri->stats_80per == TRUE) {
			CheckDlgButton(hDlg, IDC_CHECK_STATS80PER, 1);
		}

		set_enable(hDlg);

		SetWindowLong(hDlg, GWL_USERDATA, lParam);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_RADIO_STANDARD:
		case IDC_RADIO_RANDOM:
		case IDC_RADIO_HIDDEN:
		case IDC_RADIO_P2:
		case IDC_RADIO_P3:
		case IDC_RADIO_P4:
		case IDC_CHECK_R1:
		case IDC_CHECK_R2:
		case IDC_CHECK_R3:
		case IDC_CHECK_R4:
			set_enable(hDlg);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;

		case IDOK:
		case IDC_BUTTON_SAVE:
			cri = (CRICKET_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
			if (cri == NULL) {
				EndDialog(hDlg, FALSE);
				break;
			}
			// 
			ZeroMemory(cri, sizeof(CRICKET_INFO));

			// 
			if (IsDlgButtonChecked(hDlg, IDC_RADIO_HIDDEN) == 1) {
				cri->hidden = TRUE;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_RANDOM) == 1) {
				cri->random = TRUE;
			}
			cri->round_cnt = GetDlgItemInt(hDlg, IDC_EDIT_ROUND, NULL, FALSE);
			if (cri->round_cnt <= 0 || cri->round_cnt > CRICKET_ROUND_MAX) {
				cri->round_cnt = CRICKET_ROUND_MAX;
			}

			// io[ݒ
			if (cri->hidden == TRUE || cri->random == TRUE) {
				for (i = 0; i < NUMBER_CNT; i++) {
					do {
						do {
							cri->number[i] = rand() % 21;
						} while (cri->number[i] != 0 && cri->number[i] < 5);
						for (j = 0; j < i; j++) {
							if (cri->number[i] == cri->number[j]) {
								break;
							}
						}
					} while (j < i);
				}
			} else {
				for (i = 0; i < NUMBER_CNT - 1; i++) {
					cri->number[i] = 20 - i;
				}
				cri->number[NUMBER_CNT - 1] = 0;
			}

			// vC[擾
			if (IsDlgButtonChecked(hDlg, IDC_RADIO_P2) == 1) {
				cri->player_cnt = 2;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P3) == 1) {
				cri->player_cnt = 3;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P4) == 1) {
				cri->player_cnt = 4;
			} else {
				cri->player_cnt = 2;
			}

			// O
			SendDlgItemMessage(hDlg, IDC_EDIT_P1, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)cri->pi[0].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P2, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)cri->pi[1].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P3, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)cri->pi[2].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P4, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)cri->pi[3].name);

			// {
			cri->pi[0].robo = IsDlgButtonChecked(hDlg, IDC_CHECK_R1);
			cri->pi[1].robo = IsDlgButtonChecked(hDlg, IDC_CHECK_R2);
			cri->pi[2].robo = IsDlgButtonChecked(hDlg, IDC_CHECK_R3);
			cri->pi[3].robo = IsDlgButtonChecked(hDlg, IDC_CHECK_R4);
			cri->pi[0].robo_index = SendDlgItemMessage(hDlg, IDC_COMBO_R1, CB_GETCURSEL, 0, 0);
			cri->pi[1].robo_index = SendDlgItemMessage(hDlg, IDC_COMBO_R2, CB_GETCURSEL, 0, 0);
			cri->pi[2].robo_index = SendDlgItemMessage(hDlg, IDC_COMBO_R3, CB_GETCURSEL, 0, 0);
			cri->pi[3].robo_index = SendDlgItemMessage(hDlg, IDC_COMBO_R4, CB_GETCURSEL, 0, 0);
			cri->pi[0].robo_lv = SendDlgItemMessage(hDlg, IDC_COMBO_R1_LV, CB_GETCURSEL, 0, 0);
			cri->pi[1].robo_lv = SendDlgItemMessage(hDlg, IDC_COMBO_R2_LV, CB_GETCURSEL, 0, 0);
			cri->pi[2].robo_lv = SendDlgItemMessage(hDlg, IDC_COMBO_R3_LV, CB_GETCURSEL, 0, 0);
			cri->pi[3].robo_lv = SendDlgItemMessage(hDlg, IDC_COMBO_R4_LV, CB_GETCURSEL, 0, 0);

			// IvV
			if (IsDlgButtonChecked(hDlg, IDC_CHECK_CUTTHROAT) == 1) {
				cri->cut_throat = TRUE;
			}
			if (IsDlgButtonChecked(hDlg, IDC_CHECK_OVER_KILL) == 1) {
				cri->over_kill = TRUE;
			}
			if (IsDlgButtonChecked(hDlg, IDC_CHECK_STATS80PER) == 1) {
				cri->stats_80per = TRUE;
			}
			if (LOWORD(wParam) == IDC_BUTTON_SAVE) {
				// ݒۑ
				ini_put_cricket_option(ini_path, cri);
				MessageBox(hDlg, message_get_res(IDS_STRING_OP_GAME_SAVE), APP_NAME, MB_ICONINFORMATION);
			} else {
				// OK{^
				EndDialog(hDlg, TRUE);
			}
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * set_option_cricket - 01Q[ݒ
 */
BOOL set_option_cricket(const HINSTANCE hInst, const HWND hWnd, CRICKET_INFO *cri)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_OP_CRICKET), hWnd, option_cricket_proc, (LPARAM)cri);
}
/* End of source */
