/*
 * nScore
 *
 * score_halfit_list.c
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>
#include <tchar.h>
#include <stdio.h>

#include "General.h"
#include "String.h"
#include "Message.h"
#include "score_halfit.h"
#include "score_input.h"

#include "resource.h"

/* Define */
#define WM_CHANGE_VIEW				(WM_APP + 1)

#define IsNumeric(c)				(c >= TEXT('0') && c <= TEXT('9'))

/* Global Variables */

/* Local Function Prototypes */
static BOOL get_status(HALFIT_INFO *hii, const int round, TCHAR *ret);
static void listview_set_score(const HWND hListView, HALFIT_INFO *hii);
static BOOL CALLBACK score_halfit_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * get_status - Xe[^X̎擾
 */
static BOOL get_status(HALFIT_INFO *hii, const int round, TCHAR *ret)
{
	TCHAR throw_str[THROW_MAX][BUF_SIZE];
	int round_score;
	int i;

	if (round == 0) {
		if (hii->pi[hii->list_index].ri[round].score_list <= HALFIT_INIT_SCORE) {
			round_score = 0;
		} else {
			round_score = hii->pi[hii->list_index].ri[round].score_list - HALFIT_INIT_SCORE;
		}
	} else {
		if (hii->pi[hii->list_index].ri[round].score_list <= hii->pi[hii->list_index].ri[round - 1].score_list) {
			round_score = 0;
		} else {
			round_score = hii->pi[hii->list_index].ri[round].score_list - hii->pi[hii->list_index].ri[round - 1].score_list;
		}
	}
	for (i = 0; i < THROW_MAX; i++) {
		lstrcpy(throw_str[i], hii->pi[hii->list_index].ri[round].throw_list[i]);
		score_convert_str(throw_str[i]);
	}
	return get_status_string(throw_str, round_score, ret);
}

/*
 * listview_set_score - ListViewɃXRAǉ
 */
static void listview_set_score(const HWND hListView, HALFIT_INFO *hii)
{
	LV_ITEM lvi;
	TCHAR buf[BUF_SIZE];
	int i, cnt;

	ListView_DeleteAllItems(hListView);

	cnt = hii->current_round;
	if ((hii->current_player <= hii->list_index && (hii->game_flag == TRUE || hii->current_player != hii->list_index)) ||
		(cnt > hii->round_cnt && hii->list_index == 0)) {
		cnt--;
	}
	for (i = 0; i < cnt; i++) {
		lvi.mask = LVIF_TEXT | LVIF_PARAM;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		switch (hii->number[i]) {
		case CHAR_DOUBLE:
			lstrcpy(buf, message_get_res(IDS_STRING_DOUBLE));
			break;
		case CHAR_TRIPLE:
			lstrcpy(buf, message_get_res(IDS_STRING_TRIPLE));
			break;
		case 25:
			lstrcpy(buf, message_get_res(IDS_STRING_BULL));
			break;
		default:
			wsprintf(buf, TEXT("%d"), hii->number[i]);
			break;
		}
		lvi.pszText = buf;
		lvi.cchTextMax = BUF_SIZE - 1;
		lvi.iImage = 0;
		lvi.lParam = 0;
		ListView_InsertItem(hListView, &lvi);

		ListView_SetItemText(hListView, i, 1, hii->pi[hii->list_index].ri[i].throw_list[0]);
		ListView_SetItemText(hListView, i, 2, hii->pi[hii->list_index].ri[i].throw_list[1]);
		ListView_SetItemText(hListView, i, 3, hii->pi[hii->list_index].ri[i].throw_list[2]);

		if (i == 0) {
			if (hii->pi[hii->list_index].ri[i].score_list <= HALFIT_INIT_SCORE) {
				lstrcpy(buf, TEXT("0"));
			} else {
				wsprintf(buf, TEXT("%d"), hii->pi[hii->list_index].ri[i].score_list - HALFIT_INIT_SCORE);
			}
		} else {
			if (hii->pi[hii->list_index].ri[i].score_list <= hii->pi[hii->list_index].ri[i - 1].score_list) {
				lstrcpy(buf, TEXT("0"));
			} else {
				wsprintf(buf, TEXT("%d"), hii->pi[hii->list_index].ri[i].score_list - hii->pi[hii->list_index].ri[i - 1].score_list);
			}
		}
		ListView_SetItemText(hListView, i, 4, buf);

		wsprintf(buf, TEXT("%d"), hii->pi[hii->list_index].ri[i].score_list);
		ListView_SetItemText(hListView, i, 5, buf);

		if (get_status(hii, i, buf) == TRUE) {
			ListView_SetItemText(hListView, i, 6, buf);
		}
	}
}

/*
 * score_halfit_list_proc - EBhEvV[W
 */
static BOOL CALLBACK score_halfit_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HALFIT_INFO *hii;
	LV_COLUMN lvc;
	int i;

	switch (msg) {
	case WM_INITDIALOG:
		if ((hii = (HALFIT_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		SetWindowLong(hDlg, GWL_USERDATA, lParam);

		// vC[ݒ
		for (i = 0; i < hii->player_cnt; i++) {
			SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_ADDSTRING, 0, (LPARAM)hii->pi[i].name);
		}
		SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_SETCURSEL, hii->list_index, 0);

		// Xgr[ݒ
		i = 0;
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_NUMBER);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_1);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);
		
		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_2);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_3);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_ROUND_SCORE);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_SCORE);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 100;
		lvc.pszText = message_get_res(IDS_STRING_LIST_STATUS);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		// Xgr[̃X^C̐ݒ
		SetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE,
			GetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE) | LVS_SHOWSELALWAYS);
		SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
			LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES |
			SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0));

	case WM_CHANGE_VIEW:
		hii = (HALFIT_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
		if (hii == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		hii->list_index = SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_GETCURSEL, 0, 0);
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_AVERAGE), TEXT(""));
		// XRAݒ
		listview_set_score(GetDlgItem(hDlg, IDC_LIST_SCORE), hii);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_COMBO_NAME:
			if(HIWORD(wParam) == CBN_SELCHANGE){
				SendMessage(hDlg, WM_CHANGE_VIEW, 0, 0);
			}
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_score_halfit_list - XRAꗗ\
 */
BOOL show_score_halfit_list(const HINSTANCE hInst, const HWND hWnd, HALFIT_INFO *hii)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_SCORE_LIST), hWnd, score_halfit_list_proc, (LPARAM)hii);
}
/* End of source */
