/*
 * nScore
 *
 * score_rotation.h
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_SCORE_ROTATION_H
#define _INC_SCORE_ROTATION_H

/* Include Files */
#include "general.h"

/* Define */
#define ROTATION_ROUND_MAX			8

#define BULL_SCORE					50
#define BULL_COUNT					3

/* Struct */
typedef struct _ROTATION_ROUND_INFO {
	int score_list[23];
	TCHAR throw_list[23][THROW_MAX][BUF_SIZE];
	int cnt;
} ROTATION_ROUND_INFO;

typedef struct _ROTATION_PLAYER_INFO {
	TCHAR name[BUF_SIZE];
	int score;
	BOOL clear;
	BOOL win;

	ROTATION_ROUND_INFO ri[ROTATION_ROUND_MAX];
} ROTATION_PLAYER_INFO;

typedef struct _ROTATION_INFO {
	BOOL game_flag;

	int player_cnt;
	int round_cnt;

	int current_round;
	int current_player;
	int list_index;

	ROTATION_PLAYER_INFO pi[PLAYER_MAX];

} ROTATION_INFO;

/* Function Prototypes */
BOOL score_rotation_regist(const HINSTANCE hInstance);
HWND score_rotation_create(const HINSTANCE hInstance, const HWND pWnd, int id, const int height);

#endif
/* End of source */
