/*
 * nScore
 *
 * score_rotation_list.c
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>
#include <tchar.h>
#include <stdio.h>

#include "General.h"
#include "String.h"
#include "Message.h"
#include "score_rotation.h"
#include "score_input.h"

#include "resource.h"

/* Define */
#define WM_CHANGE_VIEW				(WM_APP + 1)

#define IsNumeric(c)				(c >= TEXT('0') && c <= TEXT('9'))

/* Global Variables */

/* Local Function Prototypes */
static void listview_set_score(const HWND hListView, ROTATION_INFO *rti);
static BOOL CALLBACK score_rotation_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * listview_set_score - ListViewɃXRAǉ
 */
static void listview_set_score(const HWND hListView, ROTATION_INFO *rti)
{
	LV_ITEM lvi;
	TCHAR buf[BUF_SIZE];
	int i, j, cnt;
	int n, m;

	ListView_DeleteAllItems(hListView);

	cnt = rti->current_round;
	if ((rti->current_player <= rti->list_index && (rti->game_flag == TRUE || rti->current_player != rti->list_index)) ||
		(cnt > rti->round_cnt && rti->list_index == 0)) {
		if (rti->current_player != rti->list_index || rti->pi[rti->list_index].ri[cnt - 1].cnt <= 0) {
			cnt--;
		}
	}
	n = 0;
	for (i = 0; i < cnt; i++) {
		for (j = 0; j < rti->pi[rti->list_index].ri[i].cnt; j++) {
			lvi.mask = LVIF_TEXT | LVIF_PARAM;
			lvi.iItem = n;
			lvi.iSubItem = 0;
			wsprintf(buf, TEXT("%d"), i + 1);
			lvi.pszText = buf;
			lvi.cchTextMax = BUF_SIZE - 1;
			lvi.iImage = 0;
			lvi.lParam = 0;
			ListView_InsertItem(hListView, &lvi);

			ListView_SetItemText(hListView, n, 1, rti->pi[rti->list_index].ri[i].throw_list[j][0]);
			ListView_SetItemText(hListView, n, 2, rti->pi[rti->list_index].ri[i].throw_list[j][1]);
			ListView_SetItemText(hListView, n, 3, rti->pi[rti->list_index].ri[i].throw_list[j][2]);

			if (rti->pi[rti->list_index].ri[i].score_list[j] < BULL_SCORE) {
				wsprintf(buf, TEXT("%d"), rti->pi[rti->list_index].ri[i].score_list[j]);
			} else {
				m = rti->pi[rti->list_index].ri[i].score_list[j] - BULL_SCORE;
				if (m > BULL_COUNT) m = BULL_COUNT;
				wsprintf(buf, TEXT("%s-%d"), message_get_res(IDS_STRING_BULL), m);
			}
			ListView_SetItemText(hListView, n, 4, buf);
			n++;
		}
	}
}

/*
 * score_rotation_list_proc - EBhEvV[W
 */
static BOOL CALLBACK score_rotation_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	ROTATION_INFO *rti;
	LV_COLUMN lvc;
	int i;

	switch (msg) {
	case WM_INITDIALOG:
		if ((rti = (ROTATION_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		SetWindowLong(hDlg, GWL_USERDATA, lParam);

		// vC[ݒ
		for (i = 0; i < rti->player_cnt; i++) {
			SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_ADDSTRING, 0, (LPARAM)rti->pi[i].name);
		}
		SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_SETCURSEL, rti->list_index, 0);

		// Xgr[ݒ
		i = 0;
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_ROUND);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_1);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);
		
		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_2);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_3);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_SCORE);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		// Xgr[̃X^C̐ݒ
		SetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE,
			GetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE) | LVS_SHOWSELALWAYS);
		SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
			LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES |
			SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0));

	case WM_CHANGE_VIEW:
		rti = (ROTATION_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
		if (rti == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		rti->list_index = SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_GETCURSEL, 0, 0);

		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_AVERAGE), TEXT(""));

		// XRAݒ
		listview_set_score(GetDlgItem(hDlg, IDC_LIST_SCORE), rti);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_COMBO_NAME:
			if(HIWORD(wParam) == CBN_SELCHANGE){
				SendMessage(hDlg, WM_CHANGE_VIEW, 0, 0);
			}
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_score_rotation_list - XRAꗗ\
 */
BOOL show_score_rotation_list(const HINSTANCE hInst, const HWND hWnd, ROTATION_INFO *rti)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_SCORE_LIST), hWnd, score_rotation_list_proc, (LPARAM)rti);
}
/* End of source */
