/*
 * nScore
 *
 * score_rotation_option.c
 *
 * Copyright (C) 1996-2004 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "General.h"
#include "Message.h"
#include "score_rotation.h"
#include "ini.h"

#include "resource.h"

/* Define */

/* Global Variables */
extern TCHAR ini_path[MAX_PATH];

/* Local Function Prototypes */
static void set_enable(const HWND hDlg);
static BOOL CALLBACK option_rotation_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * set_enable - Rg[̏Ԑݒ
 */
static void set_enable(const HWND hDlg)
{
	int i;

	if (IsDlgButtonChecked(hDlg, IDC_RADIO_P1) == 1) {
		i = 1;
	} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P2) == 1) {
		i = 2;
	} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P3) == 1) {
		i = 3;
	} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P4) == 1) {
		i = 4;
	}

	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P2), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P3), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P4), TRUE);

	switch (i) {
	case 1:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P2), FALSE);
	case 2:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P3), FALSE);
	case 3:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P4), FALSE);
		break;
	}
}

/*
 * option_rotation_proc - rotationݒEBhEvV[W
 */
static BOOL CALLBACK option_rotation_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	ROTATION_INFO *rti;

	switch (msg) {
	case WM_INITDIALOG:
		if ((rti = (ROTATION_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}

		// vC[ݒ
		switch (rti->player_cnt) {
		case 1:
			CheckDlgButton(hDlg, IDC_RADIO_P1, 1);
			break;
		case 2:
		default:
			CheckDlgButton(hDlg, IDC_RADIO_P2, 1);
			break;
		case 3:
			CheckDlgButton(hDlg, IDC_RADIO_P3, 1);
			break;
		case 4:
			CheckDlgButton(hDlg, IDC_RADIO_P4, 1);
			break;
		}
		// O
		SendDlgItemMessage(hDlg, IDC_EDIT_P1, WM_SETTEXT, 0,
			(LPARAM)((*rti->pi[0].name != TEXT('\0')) ? rti->pi[0].name : message_get_res(IDS_STRING_DEF_PLAYER_1)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P2, WM_SETTEXT, 0,
			(LPARAM)((*rti->pi[1].name != TEXT('\0')) ? rti->pi[1].name : message_get_res(IDS_STRING_DEF_PLAYER_2)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P3, WM_SETTEXT, 0,
			(LPARAM)((*rti->pi[2].name != TEXT('\0')) ? rti->pi[2].name : message_get_res(IDS_STRING_DEF_PLAYER_3)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P4, WM_SETTEXT, 0,
			(LPARAM)((*rti->pi[3].name != TEXT('\0')) ? rti->pi[3].name : message_get_res(IDS_STRING_DEF_PLAYER_4)));

		set_enable(hDlg);

		SetWindowLong(hDlg, GWL_USERDATA, lParam);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_RADIO_P1:
		case IDC_RADIO_P2:
		case IDC_RADIO_P3:
		case IDC_RADIO_P4:
			set_enable(hDlg);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;

		case IDOK:
		case IDC_BUTTON_SAVE:
			rti = (ROTATION_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
			if (rti == NULL) {
				EndDialog(hDlg, FALSE);
				break;
			}
			// 
			ZeroMemory(rti, sizeof(ROTATION_INFO));

			rti->round_cnt = ROTATION_ROUND_MAX;

			// vC[擾
			if (IsDlgButtonChecked(hDlg, IDC_RADIO_P1) == 1) {
				rti->player_cnt = 1;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P2) == 1) {
				rti->player_cnt = 2;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P3) == 1) {
				rti->player_cnt = 3;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P4) == 1) {
				rti->player_cnt = 4;
			}
			// O
			SendDlgItemMessage(hDlg, IDC_EDIT_P1, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)rti->pi[0].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P2, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)rti->pi[1].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P3, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)rti->pi[2].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P4, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)rti->pi[3].name);

			if (LOWORD(wParam) == IDC_BUTTON_SAVE) {
				// ݒۑ
				ini_put_rotation_option(ini_path, rti);
				MessageBox(hDlg, message_get_res(IDS_STRING_OP_GAME_SAVE), APP_NAME, MB_ICONINFORMATION);
			} else {
				// OK{^
				EndDialog(hDlg, TRUE);
			}
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * set_option_rotation - rotationݒ
 */
BOOL set_option_rotation(const HINSTANCE hInst, const HWND hWnd, ROTATION_INFO *rti)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_OP_ROTATION), hWnd, option_rotation_proc, (LPARAM)rti);
}
/* End of source */
