/*
 * nScore
 *
 * score_splat_option.c
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "General.h"
#include "Message.h"
#include "score_splat.h"
#include "ini.h"

#include "resource.h"

/* Define */

/* Global Variables */
extern TCHAR ini_path[MAX_PATH];

/* Local Function Prototypes */
static void set_enable(const HWND hDlg);
static BOOL CALLBACK option_splat_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * set_enable - Rg[̏Ԑݒ
 */
static void set_enable(const HWND hDlg)
{
	int i;

	if (IsDlgButtonChecked(hDlg, IDC_RADIO_P2) == 1) {
		i = 2;
	} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P3) == 1) {
		i = 3;
	} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P4) == 1) {
		i = 4;
	}

	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P2), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P3), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P4), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P2_D_IN), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P3_D_IN), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P4_D_IN), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P2_D_OUT), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P3_D_OUT), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P4_D_OUT), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P2_M_SPLAT), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P3_M_SPLAT), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P4_M_SPLAT), TRUE);

	switch (i) {
	case 1:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P2), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P2_D_IN), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P2_D_OUT), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P2_M_SPLAT), FALSE);
	case 2:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P3), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P3_D_IN), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P3_D_OUT), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P3_M_SPLAT), FALSE);
	case 3:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P4), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P4_D_IN), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P4_D_OUT), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P4_M_SPLAT), FALSE);
		break;
	}
}

/*
 * option_splat_proc - splatQ[ݒEBhEvV[W
 */
static BOOL CALLBACK option_splat_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	SPLAT_INFO *si;

	switch (msg) {
	case WM_INITDIALOG:
		if ((si = (SPLAT_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}

		// vC[ݒ
		switch (si->player_cnt) {
		case 2:
		default:
			CheckDlgButton(hDlg, IDC_RADIO_P2, 1);
			break;
		case 3:
			CheckDlgButton(hDlg, IDC_RADIO_P3, 1);
			break;
		case 4:
			CheckDlgButton(hDlg, IDC_RADIO_P4, 1);
			break;
		}
		// O
		SendDlgItemMessage(hDlg, IDC_EDIT_P1, WM_SETTEXT, 0,
			(LPARAM)((*si->pi[0].name != TEXT('\0')) ? si->pi[0].name : message_get_res(IDS_STRING_DEF_PLAYER_1)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P2, WM_SETTEXT, 0,
			(LPARAM)((*si->pi[1].name != TEXT('\0')) ? si->pi[1].name : message_get_res(IDS_STRING_DEF_PLAYER_2)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P3, WM_SETTEXT, 0,
			(LPARAM)((*si->pi[2].name != TEXT('\0')) ? si->pi[2].name : message_get_res(IDS_STRING_DEF_PLAYER_3)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P4, WM_SETTEXT, 0,
			(LPARAM)((*si->pi[3].name != TEXT('\0')) ? si->pi[3].name : message_get_res(IDS_STRING_DEF_PLAYER_4)));
		// _uC
		CheckDlgButton(hDlg, IDC_CHECK_P1_D_IN, si->pi[0].double_in);
		CheckDlgButton(hDlg, IDC_CHECK_P2_D_IN, si->pi[1].double_in);
		CheckDlgButton(hDlg, IDC_CHECK_P3_D_IN, si->pi[2].double_in);
		CheckDlgButton(hDlg, IDC_CHECK_P4_D_IN, si->pi[3].double_in);
		// _uAEg
		CheckDlgButton(hDlg, IDC_CHECK_P1_D_OUT, si->pi[0].double_out);
		CheckDlgButton(hDlg, IDC_CHECK_P2_D_OUT, si->pi[1].double_out);
		CheckDlgButton(hDlg, IDC_CHECK_P3_D_OUT, si->pi[2].double_out);
		CheckDlgButton(hDlg, IDC_CHECK_P4_D_OUT, si->pi[3].double_out);
		// }X^[Xvbg
		CheckDlgButton(hDlg, IDC_CHECK_P1_M_SPLAT, si->pi[0].master_splat);
		CheckDlgButton(hDlg, IDC_CHECK_P2_M_SPLAT, si->pi[1].master_splat);
		CheckDlgButton(hDlg, IDC_CHECK_P3_M_SPLAT, si->pi[2].master_splat);
		CheckDlgButton(hDlg, IDC_CHECK_P4_M_SPLAT, si->pi[3].master_splat);

		// Ehݒ
		SetDlgItemInt(hDlg, IDC_EDIT_ROUND, si->round_cnt, FALSE);
		// IvV
		CheckDlgButton(hDlg, IDC_CHECK_BULL, si->op_bull);

		set_enable(hDlg);

		SetWindowLong(hDlg, GWL_USERDATA, lParam);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_RADIO_P1:
		case IDC_RADIO_P2:
		case IDC_RADIO_P3:
		case IDC_RADIO_P4:
			set_enable(hDlg);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;

		case IDOK:
		case IDC_BUTTON_SAVE:
			si = (SPLAT_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
			if (si == NULL) {
				EndDialog(hDlg, FALSE);
				break;
			}
			// 
			ZeroMemory(si, sizeof(SPLAT_INFO));

			// vC[擾
			if (IsDlgButtonChecked(hDlg, IDC_RADIO_P2) == 1) {
				si->player_cnt = 2;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P3) == 1) {
				si->player_cnt = 3;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P4) == 1) {
				si->player_cnt = 4;
			}
			// O
			SendDlgItemMessage(hDlg, IDC_EDIT_P1, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)si->pi[0].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P2, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)si->pi[1].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P3, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)si->pi[2].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P4, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)si->pi[3].name);
			// _uC
			si->pi[0].double_in = IsDlgButtonChecked(hDlg, IDC_CHECK_P1_D_IN);
			si->pi[1].double_in = IsDlgButtonChecked(hDlg, IDC_CHECK_P2_D_IN);
			si->pi[2].double_in = IsDlgButtonChecked(hDlg, IDC_CHECK_P3_D_IN);
			si->pi[3].double_in = IsDlgButtonChecked(hDlg, IDC_CHECK_P4_D_IN);
			// _uAEg
			si->pi[0].double_out = IsDlgButtonChecked(hDlg, IDC_CHECK_P1_D_OUT);
			si->pi[1].double_out = IsDlgButtonChecked(hDlg, IDC_CHECK_P2_D_OUT);
			si->pi[2].double_out = IsDlgButtonChecked(hDlg, IDC_CHECK_P3_D_OUT);
			si->pi[3].double_out = IsDlgButtonChecked(hDlg, IDC_CHECK_P4_D_OUT);
			// }X^[Xvbg
			si->pi[0].master_splat = IsDlgButtonChecked(hDlg, IDC_CHECK_P1_M_SPLAT);
			si->pi[1].master_splat = IsDlgButtonChecked(hDlg, IDC_CHECK_P2_M_SPLAT);
			si->pi[2].master_splat = IsDlgButtonChecked(hDlg, IDC_CHECK_P3_M_SPLAT);
			si->pi[3].master_splat = IsDlgButtonChecked(hDlg, IDC_CHECK_P4_M_SPLAT);

			// Eh擾
			si->round_cnt = GetDlgItemInt(hDlg, IDC_EDIT_ROUND, NULL, FALSE);
			if (si->round_cnt <= 0 || si->round_cnt > SPLAT_ROUND_MAX) {
				si->round_cnt = SPLAT_ROUND_MAX;
			}
			// IvV
			si->op_bull = IsDlgButtonChecked(hDlg, IDC_CHECK_BULL);

			if (LOWORD(wParam) == IDC_BUTTON_SAVE) {
				// ݒۑ
				ini_put_splat_option(ini_path, si);
				MessageBox(hDlg, message_get_res(IDS_STRING_OP_GAME_SAVE), APP_NAME, MB_ICONINFORMATION);
			} else {
				// OK{^
				EndDialog(hDlg, TRUE);
			}
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * set_option_splat - splatQ[ݒ
 */
BOOL set_option_splat(const HINSTANCE hInst, const HWND hWnd, SPLAT_INFO *si)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_OP_SPLAT), hWnd, option_splat_proc, (LPARAM)si);
}
/* End of source */
